## nplan 0.12

=== Makefile ===
BUILDFLAGS = \
	-std=c99 \
	-D_XOPEN_SOURCE=500 \
	-Wall \
	-Werror=incompatible-pointer-types \
	-Werror=implicit-function-declaration \
	-Werror=format \
	$(NULL)

SYSTEMD_GENERATOR_DIR=$(shell pkg-config --variable=systemdsystemgeneratordir systemd)

PYCODE = src/netplan $(wildcard src/*.py) $(wildcard tests/*.py)

default: generate doc/netplan.5 doc/netplan.html

generate: src/generate.[hc] src/parse.[hc] src/util.[hc] src/networkd.[hc] src/nm.[hc]
	$(CC) $(BUILDFLAGS) $(CFLAGS) -o $@ $(filter %.c, $^) `pkg-config --cflags --libs glib-2.0 yaml-0.1 uuid`

clean:
	rm -f generate doc/*.html doc/*.[1-9]
	rm -rf test-coverage .coverage

check: default
	tests/generate.py
	tests/cli.py
	$(shell which pyflakes3 || echo true) $(PYCODE)
	$(shell which pycodestyle || which pep8 || echo true) --max-line-length=130 $(PYCODE)

coverage:
	rm -f .coverage
	$(MAKE) CFLAGS="-g -O0 --coverage" clean check
	lcov --directory . --capture -o generate.info
	lcov --remove generate.info "/usr*" -o generate.info
	genhtml -o test-coverage -t "generate test coverage" generate.info
	@rm *.gcda *.gcno generate.info generate
	@echo "generated report: file://$(CURDIR)/test-coverage/index.html"
	@if grep headerCovTableEntryHi test-coverage/index.html | grep -qv '100.*%'; then \
	    echo "FAIL: Test coverage not 100%!" >&2; exit 1; \
	fi
	python3-coverage report --include=src/netplan --show-missing

install: default
	mkdir -p $(DESTDIR)/usr/sbin $(DESTDIR)/lib/netplan $(DESTDIR)/$(SYSTEMD_GENERATOR_DIR)
	mkdir -p $(DESTDIR)/usr/share/man/man5 $(DESTDIR)/usr/share/doc/netplan
	install -m 755 generate $(DESTDIR)/lib/netplan/
	install -m 755 src/netplan $(DESTDIR)/usr/sbin/
	ln -s /lib/netplan/generate $(DESTDIR)/$(SYSTEMD_GENERATOR_DIR)/netplan
	install -m 644 doc/*.html $(DESTDIR)/usr/share/doc/netplan/
	install -m 644 doc/*.5 $(DESTDIR)/usr/share/man/man5/
	install -D -m 644 src/netplan-wpa@.service $(DESTDIR)/`pkg-config --variable=systemdsystemunitdir systemd`/netplan-wpa@.service

%.html: %.md
	pandoc -s --toc -o $@ $<

doc/netplan.5: doc/netplan.md
	pandoc -s -o $@ $<
	# add NAME section (looks ugly in HTML, thus only do it here)
	sed -i '/^.TH/ a\.SH NAME\nnetplan \\- YAML network configuration abstraction for various backends' $@

.PHONY: clean

=== debian/changelog ===
nplan (0.12) yakkety; urgency=medium

  * netplan apply: Ignore Non-symlinks in /sys/class/net
  * tests/integration.py: Stop upping client veth interfaces
  * Add support for bonds

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 30 Aug 2016 10:32:17 +0200

nplan (0.11.1) yakkety; urgency=medium

  * tests/integration.py: Clean up wpa_supplicant in between tests

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 30 Aug 2016 07:21:02 +0200

nplan (0.11) yakkety; urgency=medium

  * Support /lib/netplan/*.yaml files.
    This is useful for configuration snippets shipped by packages.
  * Add networkd support for wifi (LP: #1616928)
    networkd cannot handle wifi natively, so generate a wpa_supplicant
    configuration and unit that does the WLAN part and leave the IP part to
    networkd.
    This supports open and WPA2, and infrastructure and adhoc mode. "match:" is not
    supported as the netplan-wpa@.service helper unit is bound to the named network
    interface device unit.
  * As networkd can now handle wifi devices, use networkd consistently as a default
    renderer.
  * tests/integration.py: Kill leftover NetworkManager processes between tests.
    NetworkManager.service has KillMode=process and leaks dhclient processes.
  * Fix package description for updated yaml paths

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 29 Aug 2016 17:25:33 +0200

nplan (0.10) yakkety; urgency=medium

  * Add "netplan ifupdown-migrate" command.
    This supports converting "loopback" (no-op) and "dhcp" interfaces (without
    options) for now.
  * Add "dhcp6:" option
  * Add "gateway[46]:" options
  * Ship empty /etc/netplan in the package
  * NM: Explicitly disable implied DHCP default when DHCP is not enabled.
    (LP: #1617051)
  * tests/integration.py: Quiesce systemd-networkd-wait-online.
  * Add support for VLAN.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Sun, 28 Aug 2016 21:25:45 +0200

nplan (0.9) yakkety; urgency=medium

  * tests/integration.py: Improve debug messages on failure
  * netplan apply: disconnect devices from NetworkManager before restarting.
    Merely restarting NetworkManager does not suffice to apply a changed
    configuration, so disconnect managed devices first.
    Add autopkgtest to reproduce the problem and confirm the fix.
  * Fix configuration path in package description
  * networkd: Change generated config file prefix to "10-netplan"
    Just "netplan-*" sorts after /lib/systemd/network/99-default.link.
  * netplan apply: Force-replug network devices which are down to apply renames.
    Unbind/rebind network devices from their driver to simulate a hotplug, so
    that device renames get applied. Don't do this for devices which are up
    (or "unknown") though, to avoid disrupting existing network connections.
  * tests/integration.py: Add workaround for NM "unmanaged-devices="
    mishandling (LP #1615044)

 -- Martin Pitt <martin.pitt@ubuntu.com>  Fri, 19 Aug 2016 19:10:33 +0200

nplan (0.8) yakkety; urgency=medium

  * tests/cli.py: Test "generate" more precisely
  * Let "make coverage" fail if coverage is < 100%
  * Support /run/netplan/*.yaml files.
    This is useful if you want to try out a new network config before
    "committing" it to /etc: if your remote server is still reachable after
    "apply", you copy the files to /etc; otherwise rebooting will go back to
    the known-good state.
  * If global renderer is set to NM, allow NM to manage all devices.
    By default, NetworkManager only manages wifi and wwan devices (via
    /usr/lib/NetworkManager/conf.d/10-globally-managed-devices.conf). If
    global renderer is set to NetworkManager, disable that file in /run so
    that NM will once again manage all devices. This should be configured on
    desktop systems.
  * netplan apply: Asynchronously restart networkd/NM.
    This avoids deadlocks when calling "apply" during the boot sequence.
    (LP: #1614061)

 -- Martin Pitt <martin.pitt@ubuntu.com>  Wed, 17 Aug 2016 16:03:33 +0200

nplan (0.7) yakkety; urgency=medium

  * tests/cli.py: Fix TestGenerate to not depend on installed netplan

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 16 Aug 2016 16:39:11 +0200

nplan (0.6) yakkety; urgency=medium

  * Enable systemd-networkd-wait-online when starting networkd (LP: #1613548)
  * networkd: Prefix generated files with "netplan-"
  * generate: Clean up obsolete generated configs (LP: #1608223)
  * Prefer pycodestyle over pep8
  * Add initial "netplan" CLI. This implements commands "generate" and "apply"
    (partially) for now.
  * tests/integration.py: Use systemd-networkd-wait-online instead of polling
  * netplan.5: Add missing NAME section

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 16 Aug 2016 16:23:02 +0200

nplan (0.5) yakkety; urgency=medium

  * Recognize booean values as per YAML spec (LP: #1606839)
  * Add explicit systemd test dependency
  * networkd: Disable LinkLocalAddressing and RA for bridge components
  * Move "generate" from a systemd unit to a systemd generator
  * Automatically start networkd iff there is any networkd configuration
    (LP: #1607693)

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 01 Aug 2016 17:27:54 +0200

nplan (0.4) yakkety; urgency=medium

  * tests/integration.py: Avoid stderr output on reset-failed
  * Document configuration (man, html)

 -- Martin Pitt <martin.pitt@ubuntu.com>  Fri, 29 Jul 2016 10:45:33 +0200

nplan (0.3) yakkety; urgency=medium

  * Properly terminate wifi_access_point_handlers list

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 26 Jul 2016 21:57:26 +0200

nplan (0.2) yakkety; urgency=medium

  * Fix unstable TestConfigArgs.test_file_args() test
  * Add license/copyright headers to all source files

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 26 Jul 2016 16:29:26 +0200

nplan (0.1) yakkety; urgency=medium

  * Initial release.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Tue, 26 Jul 2016 16:14:37 +0200

## nplan 0.14%7e16.04

=== debian/changelog ===
nplan (0.14~16.04) xenial; urgency=medium

  * Update to 0.14 for xenial.
  * tests/integration.py: Re-enable search domain check, that fix landed in
    xenial.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Wed, 09 Nov 2016 17:00:31 +0100

nplan (0.14) zesty; urgency=medium

  * tests/generate.py: Introduce macros for commonly expected networkd output
  * networkd: Use NetworkManager compatible DHCP route metrics (LP: #1639754)
  * doc/netplan.md: Fix wrong wifi reference in "br0" example
  * doc/netplan.md: Clarify introduction
  * tests/integration.py: Fix race condition with waiting for networkd

 -- Martin Pitt <martin.pitt@ubuntu.com>  Wed, 09 Nov 2016 16:57:49 +0100

nplan (0.13~16.04) xenial; urgency=medium

  [ Martin Pitt ]
  * Update to 0.13.
  * tests/integration.py: Disable search domain check in /etc/resolv.conf with
    networkd, until this gets fixed in systemd (see LP: #1635256)

  [ Simon Fels ]
  * src/netplan: Use absolute path to the nmcli utility provided by the
    network-manager snap. Contributes to LP #1633004.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Thu, 20 Oct 2016 16:44:36 +0200

nplan (0.13) zesty; urgency=medium

  [ Jonathan Cave ]
  * Blacklist mwifiex_pcie from rebinds (work around LP: #1630285)

  [ Martin Pitt ]
  * Add support for nameservers (LP: #1626617)

 -- Martin Pitt <martin.pitt@ubuntu.com>  Thu, 20 Oct 2016 16:23:58 +0200

nplan (0.12~16.04) xenial; urgency=medium

  [ Martin Pitt ]
  * Backport to xenial. (LP: #1627641)
  * Adjust Breaks: network-manager to version in xenial that provides the
    "read config from /run" functionality.
  * src/netplan: Add hack to support current NetworkManager snap, which
    currently cannot provide "nmcli" and "NetworkManager.service". Note that
    this is meant to be temporary until snapd gets fixed, and will NOT be
    applied to yakkety or upstream. Patch by Simon Fels.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 26 Sep 2016 11:06:57 +0200

=== debian/control ===
Source: nplan
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
Section: net
Priority: standard
Standards-Version: 3.9.8
Build-Depends: debhelper (>= 9),
 pkg-config,
 libyaml-dev,
 libglib2.0-dev,
 uuid-dev,
 python3 (>= 3.1),
 python3-coverage,
 python3-yaml,
 systemd,
 pyflakes3,
 pycodestyle | pep8,
 pandoc,
Vcs-Git: https://git.launchpad.net/~netplan-developers/netplan
Vcs-Browser: https://git.launchpad.net/~netplan-developers/netplan

Package: nplan
Architecture: any
Multi-Arch: foreign
Depends: ${shlibs:Depends},
 ${misc:Depends},
 systemd,
 python3,
 python3-yaml,
Suggests: network-manager | wpasupplicant
Breaks: network-manager (<< 1.2.2-0ubuntu0.16.04.2~)
Description: YAML network configuration abstraction for various backends
 netplan reads YAML network configuration files which are written
 by administrators, installers, cloud image instantiations, or other OS
 deployments. During early boot it then generates backend specific
 configuration files in /run to hand off control of devices to a particular
 networking daemon.
 .
 Currently supported backends are networkd and NetworkManager.

## nplan 0.16

=== debian/changelog ===
nplan (0.16) zesty; urgency=medium

  [ Martin Pitt ]
  * doc/example-config: Adjust "routes:" example.
    It does not make sense to make "routes:" a global thing, they should be
    tied to an interface so that the route is only set when the corresponding
    interface exists and is up, and the config is not split in two parts.
  * doc/netplan.md: Point out that NM does not support globbing (LP: #1631018)

  [ Mathieu Trudel-Lapierre ]
  * Fix coverage for src/netplan to be 100%, and fail if coverage falls below
    that mark again.
  * Add support for specifying routes.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Fri, 23 Dec 2016 12:33:34 -0500

nplan (0.15) zesty; urgency=medium

  * tests/generate.py: Fix PEP-8 error (newly detected by -proposed
    pycodestyle).

 -- Martin Pitt <martin.pitt@ubuntu.com>  Wed, 09 Nov 2016 17:12:54 +0100

## nplan 0.18

=== debian/changelog ===
nplan (0.18) zesty; urgency=medium

  * debian/tests/integration.py: in some cases 'iw reg get' may qualify the
    reg domain results with 'global'; we must not let that trip up tests when
    they are run on Ubuntu infrastructure vs. local tests.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Tue, 07 Feb 2017 11:12:37 -0500

nplan (0.17) zesty; urgency=medium

  * New release:
    - Add support for configuring bonds.
    - Add support for configuring bridges.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Wed, 01 Feb 2017 18:35:45 -0500

## nplan 0.19

=== debian/changelog ===
nplan (0.19) zesty; urgency=medium

  * Add support for unordered definition of network devices: you can now
    specify a virtual devices before their member devices. (LP: #1670495)
  * Allow setting up the STP state for a bridge. (LP: #1665088)
  * Document bond/bridge parameters support. (LP: #1664702)

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 09 Mar 2017 11:04:50 -0500

## nplan 0.20

=== debian/changelog ===
nplan (0.20) zesty; urgency=medium

  * tests/integration.py: increase timeout for integration tests (networkd and
    NetworkManager "wait-online" checks) to account for longer bring-up times
    when dealing with stacked virtual devices.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Tue, 04 Apr 2017 21:26:01 -0400

=== debian/control ===
--- 
+++ 
@@ -27,7 +27,7 @@
  python3,
  python3-yaml,
 Suggests: network-manager | wpasupplicant
-Breaks: network-manager (<< 1.2.2-0ubuntu0.16.04.2~)
+Breaks: network-manager (<< 1.2.2-0ubuntu4~)
 Description: YAML network configuration abstraction for various backends
  netplan reads YAML network configuration files which are written
  by administrators, installers, cloud image instantiations, or other OS

## nplan 0.23~16.10.1

=== Makefile ===
--- 
+++ 
@@ -37,7 +37,7 @@
 	@if grep headerCovTableEntryHi test-coverage/index.html | grep -qv '100.*%'; then \
 	    echo "FAIL: Test coverage not 100%!" >&2; exit 1; \
 	fi
-	python3-coverage report --include=src/netplan --show-missing
+	python3-coverage report --include=src/netplan --show-missing --fail-under=100
 
 install: default
 	mkdir -p $(DESTDIR)/usr/sbin $(DESTDIR)/lib/netplan $(DESTDIR)/$(SYSTEMD_GENERATOR_DIR)

=== debian/changelog ===
nplan (0.23~16.10.1) yakkety; urgency=medium

  * Backport netplan 0.23 to 16.10. (LP: #1688632)

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Tue, 06 Jun 2017 17:25:57 -0700

nplan (0.23) artful; urgency=medium

  * Do not unbind brcmfmac, interface will be gone. (LP: #1696162)

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Tue, 06 Jun 2017 12:25:22 -0400

nplan (0.22) artful; urgency=medium

  * Add support for setting a custom MAC address on all device types.
    (LP: #1690388)
  * Improved MAC/vlan integration tests; thanks for Dimitri John Ledkov for the
    changes.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Mon, 22 May 2017 11:57:39 -0400

nplan (0.21) artful; urgency=medium

  [ Ryan Harper ]
  * Add support for setting MTU on a device. (LP: #1668693)

  [ Mathieu Trudel-Lapierre ]
  * Don't rebind Atheros AR9271; it would confuse the driver. (LP: #1672740)
  * debian/control: Add Conflicts: against netplan; the network 'plan' daemon.
    Both ship the same /usr/sbin/netplan. (LP: #1665842)

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Tue, 02 May 2017 09:37:57 -0400

=== debian/control ===
--- 
+++ 
@@ -28,6 +28,7 @@
  python3-yaml,
 Suggests: network-manager | wpasupplicant
 Breaks: network-manager (<< 1.2.2-0ubuntu4~)
+Conflicts: netplan
 Description: YAML network configuration abstraction for various backends
  netplan reads YAML network configuration files which are written
  by administrators, installers, cloud image instantiations, or other OS

=== debian/tests/control ===
Tests: integration.py
Tests-Directory: tests
Depends: @,
  systemd,
  network-manager,
  hostapd,
  dnsmasq-base,
Restrictions: needs-root, isolation-machine

Tests: autostart
Restrictions: needs-root, isolation-container

## nplan 0.30

=== debian/changelog ===
nplan (0.30) artful; urgency=medium

  * Add an "optional" syntax node for now to all devices. This is unimplemented
    for now, but intended to allow users to mark some devices as optional: to
    make sure they do not delay boot when configured. (LP: #1664844)

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Wed, 11 Oct 2017 21:26:48 -0400

nplan (0.29) artful; urgency=medium

  * Fix autopkgtests in a world where /run/NetworkManager/conf.d already
    exists. nplan is enabled by default, so it might well have the directory
    already created on the filesystem.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Tue, 19 Sep 2017 15:24:17 -0400

nplan (0.28) artful; urgency=medium

  * Revert 56cd3eec which disabled IPv6 Router Advertisements by default. It
    broke default network config in LXD and was contrary to the defaults used
    by the kernel. Reopens LP: 1655440. (LP: #1717404)
  * Add "accept-ra:" key for all device types; this will default to OFF but
    allow users to disable processing Router Advertisements when required by
    their network setup. (LP: #1655440)

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Mon, 18 Sep 2017 16:11:45 -0700

nplan (0.27) artful; urgency=medium

  [ Mathieu Trudel-Lapierre ]
  * Fix crash in systemd generator if called by an user on the command-line
  * coverage: fix exclusions to properly not cover our "never reached defaults"

  [ Dimitri John Ledkov ]
  * tests/integration.py: In teardown, stop systemd-networkd.socket.
  * src/networkd.c: Set UseMTU=true by default, whenever DHCP is in use.
    (LP: #1717471)
  * tests/integration.py: fix resolved detection.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 15 Sep 2017 14:25:22 +0100

nplan (0.26) artful; urgency=medium

  * Bonding:
    - Add support for specifying a primary slave. (LP: #1709135)
  * Rebind:
    - Fix brcmfmac harder. Treat any 'brcmfmac' driver as not supporting
      rebind. (LP: #1712224)
  * Autopkgtests:
    - Add allow-stderr. Systemd now bleats about a the networkd socket still
      being around and enabled when we restart the service; but we don't need
      to care since we're /restarting/ the service to load the new config.
    - Fix the autostart package to be more sensible: we don't really care if
      networkd autostarts or not, but we need to make sure that our generator
      will run at boot, so instead check the state, but only assert it once
      we've added a config file and before checking the state of our dummy
      device.
    - Do a bit more to make sure "mix" tests which stack virtual devices are
      as reliable as possible; by setting saner defaults.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Wed, 23 Aug 2017 19:32:33 -0400

nplan (0.25) artful; urgency=medium

  * tests/generate.py: add a test to validate that correct blacklist entries
    are added when creating virtual devices.
  * tests/integration.py: clean up after br0 in networkd's test_bridge_mac; as
    the remaining interface and udev configuration can confuse NetworkManager
    now that it seems to manage random devices it did not create again.
    (LP: #1699371)
  * src/nm.c: set the MTU even though we also specify it in systemd-networkd
    for consumption by udev. NetworkManager will try to set it and might
    otherwise default to the wrong value.
  * src/networkd.c: Set IPv6AcceptRA=no anytime we don't do DHCPv6 (or by the
    same config, SLAAC), and don't have static addresses set. This should fix
    the cases where unconfigured devices still get an IPv6 address.
    (LP: #1655440)
  * src/nm.c: Explicitly set IPv6 method=ignore when IPv6 is otherwise not
    configured; this follows the same logic as setting IPv6AcceptRA=no in
    networkd, with the exception that NM does not currently disable RAs. When
    it does, an unconfigured device for IPv6 will truly be left with no config.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 13 Jul 2017 16:22:18 -0400

nplan (0.24) artful; urgency=medium

  * debian/control: set Priority to important to make sure we can get into
    minimal.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 15 Jun 2017 21:37:51 -0400

## nplan 0.32~16.04.7

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,11 @@
+PREFIX ?= /usr
+SBINDIR ?= $(PREFIX)/sbin
+LIBEXECDIR ?= $(PREFIX)/lib
+
 BUILDFLAGS = \
 	-std=c99 \
 	-D_XOPEN_SOURCE=500 \
+	-DSBINDIR=\"$(SBINDIR)\" \
 	-Wall \
 	-Werror=incompatible-pointer-types \
 	-Werror=implicit-function-declaration \
@@ -9,14 +14,18 @@
 
 SYSTEMD_GENERATOR_DIR=$(shell pkg-config --variable=systemdsystemgeneratordir systemd)
 
-PYCODE = src/netplan $(wildcard src/*.py) $(wildcard tests/*.py)
+PYCODE = src/netplan $(wildcard src/*.py) $(wildcard tests/*.py)  $(wildcard tests/dbus/*.py)
 
-default: generate doc/netplan.5 doc/netplan.html
+default: generate doc/netplan.5 doc/netplan.html netplan-dbus dbus/io.netplan.Netplan.service
 
 generate: src/generate.[hc] src/parse.[hc] src/util.[hc] src/networkd.[hc] src/nm.[hc]
 	$(CC) $(BUILDFLAGS) $(CFLAGS) -o $@ $(filter %.c, $^) `pkg-config --cflags --libs glib-2.0 yaml-0.1 uuid`
 
+netplan-dbus: src/dbus.c
+	$(CC) $(BUILDFLAGS) $(CFLAGS) -o $@ $^ `pkg-config --cflags --libs libsystemd glib-2.0`
+
 clean:
+	rm -f netplan-dbus dbus/*.service
 	rm -f generate doc/*.html doc/*.[1-9]
 	rm -rf test-coverage .coverage
 
@@ -48,6 +57,14 @@
 	install -m 644 doc/*.html $(DESTDIR)/usr/share/doc/netplan/
 	install -m 644 doc/*.5 $(DESTDIR)/usr/share/man/man5/
 	install -D -m 644 src/netplan-wpa@.service $(DESTDIR)/`pkg-config --variable=systemdsystemunitdir systemd`/netplan-wpa@.service
+	# dbus
+	mkdir -p $(DESTDIR)/usr/share/dbus-1/system.d $(DESTDIR)/usr/share/dbus-1/system-services
+	install -m 755 netplan-dbus $(DESTDIR)/lib/netplan/
+	install -m 644 dbus/io.netplan.Netplan.conf $(DESTDIR)/usr/share/dbus-1/system.d/
+	install -m 644 dbus/io.netplan.Netplan.service $(DESTDIR)/usr/share/dbus-1/system-services/
+
+%.service: %.service.in
+	sed -e "s#@ROOTLIBEXECDIR@#/lib#" $< > $@
 
 %.html: %.md
 	pandoc -s --toc -o $@ $<

=== debian/changelog ===
nplan (0.32~16.04.7) xenial; urgency=medium

  * Backport DBus support to 16.04. (LP: #1842511)
  * debian/control: add libsystemd-dev to Build-Depends, required for this new
    DBus support.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 05 Sep 2019 12:58:36 -0400

nplan (0.32~16.04.6) xenial; urgency=medium

  [ Mathieu Trudel-Lapierre ]
  * tests/integration.py: Fix autopkgtests involving bonds/bridges to do proper
    cleanup every time, so later tests don't unnecessarily wait for an
    interface not configured to be up. (LP: #1775097)

  [ Daniel Axtens ]
  * Generate udev rules files to rename devices (LP: #1770082)
    Due to a systemd issue[1], using link files to rename interfaces
    doesn't work as expected. Link files will not rename an interface
    if it was already renamed, and interfaces are renamed in initrd, so
    set-name will often not work as expected when rebooting. However,
    rules files will cause a renaming, even if the interface has been
    renamed in initrd.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Tue, 03 Jul 2018 12:55:11 -0400

nplan (0.32~16.04.5) xenial; urgency=medium

  * bond/bridge: Support suffixes for time-based values so things like
    "mii-monitor-interval" can support milliseconds. (LP: #1745597)
  * Do not attempt to rebind driver 'qeth'. (LP: #1756322)
  * Allow setting ClientIdentifier=mac for networkd-renderered devices
    (LP: #1738998)
  * IPv6: accept-ra should default to being unset, so that the kernel default
    can be used. (LP: #1732002)
  * doc/netplan.md: Clarify the behavior for time-based values for bonds
    and bridges. (LP: #1756587)
  * critical: provide a way to set "CriticalConnection=true" on a networkd
    connection, especially for remote-fs scenarios. (LP: #1769682)
  * networkd: don't wipe out /run/netplan on generate: we do want to keep any
    YAML configurations in that directory, we just need to remove generated
    wpasupplicant configs. (LP: #1764869)

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Tue, 08 May 2018 10:36:24 -0400

nplan (0.32~16.04.4) xenial; urgency=medium

  [ Oliver Grawert ]
  * Prevent unbinding ath6kl_sdio, driver does not support it correctly.
    (LP: #1741910)

  [ Mathieu Trudel-Lapierre ]
  * Re-add snap support patch. (LP: #1747714)
  * Fix syntax for IPv6 addresses in doc. (LP: #1735317)
  * doc: routes are not top-level but per-interface. (LP: #1726695)
  * Implement bridge port-priority parameter. (LP: #1735821)
  * Implement "optional: true" to correctly write systemd network definitions
    with "RequiredForOnline=false", such that these networks do not block boot.
    (LP: #1664844)
  * Various documentation fixes. (LP: #1751814)

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Fri, 02 Mar 2018 17:02:03 -0500

nplan (0.32~16.04.3) xenial; urgency=medium

  * tests/integration.py: Really fix skipping test_routes_v6 for the NM
    backend.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Mon, 04 Dec 2017 10:57:34 -0500

nplan (0.32~16.04.2) xenial; urgency=medium

  * tests/integration.py: Fix test_routes_v6 that I clobbered when I re-applied
    the skip rules for 16.04 after merging in 0.32.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Tue, 28 Nov 2017 11:53:55 -0500

nplan (0.32~16.04.1) xenial; urgency=medium

  * Backport netplan 0.32 to 16.04. (LP: #1713142)
  * debian/control: Depend on systemd (>= 229-4ubuntu20) for the PrimarySlave
    feature backported in that revision.
  * tests/integration.py: Skip tests that are still not yet supported in xenial

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 16 Nov 2017 10:13:28 -0500

nplan (0.32) bionic; urgency=medium

  * src/nm.c: better handle the UUID generation; the order of iterating
    through interaces may affect things here. Also make sure the tests catch
    a null UUID.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Tue, 14 Nov 2017 08:53:51 -0500

nplan (0.31) bionic; urgency=medium

  [ Mathieu Trudel-Lapierre ]
  * src/nm.c: generate a UUID for a connection only as needed; when we're
    dealing with NM VLANs. (LP: #1712921)
  * debian/tests/autostart: Make the autostart test more verbose and avoid
    failing right from the start when systemd-networkd is disabled.
    (LP: #1699371)
  * tests/integration.py: bump the NetworkManager timeout for settling to
    120 seconds, autopkgtest infrastructure tends to be a little slow for the
    network device configuration to be applied and noticed by NM.
    (LP: #1699371)

  [ Dimitri John Ledkov ]
  * Reload udevd to invalidate configuration cache of .rules/.link files
    as generate step may have changed them. LP: #1669564

  [ Dan Streetman ]
  * Add another interface driver exception to netplan replug to prevent unbind
    of the Xen VIF interfaces. (LP: #1729573)

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Wed, 08 Nov 2017 14:02:39 -0500

=== debian/control ===
--- 
+++ 
@@ -1,7 +1,7 @@
 Source: nplan
 Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 Section: net
-Priority: standard
+Priority: important
 Standards-Version: 3.9.8
 Build-Depends: debhelper (>= 9),
  pkg-config,
@@ -11,6 +11,7 @@
  python3 (>= 3.1),
  python3-coverage,
  python3-yaml,
+ libsystemd-dev,
  systemd,
  pyflakes3,
  pycodestyle | pep8,
@@ -23,7 +24,7 @@
 Multi-Arch: foreign
 Depends: ${shlibs:Depends},
  ${misc:Depends},
- systemd,
+ systemd (>= 229-4ubuntu20),
  python3,
  python3-yaml,
 Suggests: network-manager | wpasupplicant

## nplan 0.32~17.04.1

=== debian/changelog ===
nplan (0.32~17.04.1) zesty; urgency=medium

  * Backport 0.32 to 17.04. (LP: #1713142)

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 16 Nov 2017 10:43:28 -0500

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,6 @@
  python3 (>= 3.1),
  python3-coverage,
  python3-yaml,
- libsystemd-dev,
  systemd,
  pyflakes3,
  pycodestyle | pep8,
@@ -24,7 +23,7 @@
 Multi-Arch: foreign
 Depends: ${shlibs:Depends},
  ${misc:Depends},
- systemd (>= 229-4ubuntu20),
+ systemd,
  python3,
  python3-yaml,
 Suggests: network-manager | wpasupplicant

## nplan 0.32~17.10.4

=== debian/changelog ===
nplan (0.32~17.10.4) artful; urgency=medium

  * bond/bridge: Support suffixes for time-based values so things like
    "mii-monitor-interval" can support milliseconds. (LP: #1745597)
  * debian/postinst: Write breadcrumbs on disk in /etc/network/interfaces to
    denote the migration to using netplan. (LP: #1756742)
  * DHCPv4: add a "dhcp-identifier: mac" field that can be set to fix interop
    with Windows Server-based DHCP servers which don't support RFC 4361.
    (LP: #1738998)
  * IPv6: accept-ra should default to being unset, so that the kernel default
    can be used. (LP: #1732002)
  * doc/netplan.md: Clarify the behavior for time-based values for bonds
    and bridges. (LP: #1756587)
  * critical: provide a way to set "CriticalConnection=true" on a networkd
    connection, especially for remote-fs scenarios. (LP: #1769682)
  * networkd: don't wipe out /run/netplan on generate: we do want to keep any
    YAML configurations in that directory, we just need to remove generated
    wpasupplicant configs. (LP: #1764869)

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Tue, 08 May 2018 11:04:30 -0400

nplan (0.32~17.10.3) artful; urgency=medium

  * Don't silently break Bridge Priority by adding port-priority.

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Fri, 02 Mar 2018 16:50:47 -0500

nplan (0.32~17.10.2) artful; urgency=medium

  * Fix syntax for IPv6 addresses in doc. (LP: #1735317)
  * doc: routes are not top-level but per-interface. (LP: #1726695)
  * Implement bridge port-priority parameter. (LP: #1735821)
  * Implement "optional: true" to correctly write systemd network definitions
    with "RequiredForOnline=false", such that these networks do not block boot.
    (LP: #1664844)
  * Various documentation fixes. (LP: #1751814)

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Mon, 26 Feb 2018 11:07:39 -0500

nplan (0.32~17.10.1) artful; urgency=medium

  * Backport 0.32 to Ubuntu 17.10. (LP: #1713142)

 -- Mathieu Trudel-Lapierre <cyphermox@ubuntu.com>  Thu, 23 Nov 2017 12:30:51 -0500
